murder = {}

murder.alphabet = {"Alfa", "Bravo", "Charlie", "Delta", "Echo", "Foxtrot", "Golf", "Hotel", "India", "Juliet", "Kilo", "Lima", "Mike", "November", "Oscar", "Papa", "Quebec", "Romeo", "Sierra", "Tango", "Uniform", "Victor", "Whiskey", "X-ray", "Yankee", "Zulu"} -- Bank of all words used in names (only two words for one name)
murder.colors = {"000140110", "030020185", "220110110", "080120080", "000110110", "100100200", "095180180", "000200090", "150115150", "220180220", "200225130"} -- Bank of all name colors
murder.nokillsecs = 60 -- After this many seconds, the murderer's evil presence will start showing
murder.loot = {"gfx/murder/clue_passport.png", "gfx/murder/clue_phone.png", "gfx/murder/clue_money.png", "gfx/murder/clue_paper.png", "gfx/murder/clue_fingerprint.png", "gfx/murder/clue_blood.png", "gfx/murder/clue_knife.png"} -- Images for loot

murder.int_bodies = {}
murder.int_loot = {}
murder.int_lootc = {}
murder.int_fresh = {}
murder.int_kinnoc = {}
murder.int_murdered = {}
murder.int_blind = 0
murder.int_lootcounter = 0
murder.int_names = {}
murder.int_shots = {}
murder.int_murderer = 0
murder.int_gunner = 0
murder.int_nokillsecs = 0

parse("sv_gamemode 1")
parse("mp_hovertext 12")
parse("mp_hud 0")
parse("mp_radar 0")

function murder.int_contains(t, e)
	for k, v in pairs(t) do if v == e then return k end end return false
end

function murder.int_randomtile()
	local x, y = math.random(0, map("xsize")), math.random(0, map("ysize"))
	local lq = 0
	while (tile(x, y, "walkable") == false or tile(x, y, "frame") == 0) do
		x, y = math.random(0, map("xsize")), math.random(0, map("ysize"))
		lq = lq + 1
		if (lq > 1000) then print(string.char(169).."255000000ERROR: loop quota exceeded") break end
	end
	return x, y
end

function murder.int_hudtxt2(id, ply, txt, x, y, align)
	parse("hudtxt2 "..ply.." "..id.." \""..txt.."\" "..x.." "..y.." "..(align or 0))
end
local hudtxt2 = murder.int_hudtxt2

function murder.murder(ply)
	for _, id in pairs(playerweapons(ply)) do
		if (id == 3) then
			parse("spawnitem 3 "..player(ply, "tilex").." "..player(ply, "tiley"))
			parse("setammo "..item(0, "table")[#item(0, "table")].." 0 1 "..murder.int_shots[ply])
		end
	end
	parse('customkill 0 "the murderer" '..ply)
	murder.int_nokillsecs = 0
	murder.int_bodies[#murder.int_bodies+1] = {image("gfx/murder/dead_body.png", player(ply, "x"), player(ply, "y"), 0), ply, player(ply, "x"), player(ply, "y")}
	imagepos(murder.int_bodies[#murder.int_bodies][1], player(ply, "x"), player(ply, "y"), math.random(0, 359))
	murder.int_murdered[ply] = true
end

function murder.reload(ply, mode)
	if (mode == 2) then
		murder.int_shots[ply] = murder.int_shots[ply] - 1
		parse("setammo "..ply.." 3 1 "..murder.int_shots[ply])
	end
end

function murder.spawn(ply)
	if (#player(0, "table") > 1) then
		local x, y = murder.int_randomtile()
		parse("setpos "..ply.." "..x*32+16 .." "..y*32+16)
		parse("speedmod "..ply.." -100")
		timer(50, "parse", "setweapon "..ply.." 78")
		if (murder.int_murderer == ply) then
			return "78,50"
		elseif (murder.int_gunner == ply) then
			if not murder.int_shots[ply] then murder.int_shots[ply] = 5 end
			timer(50, "parse", "setammo "..ply.." 3 1 "..murder.int_shots[ply])
			return "3,78"
		else
			parse("strip "..ply.." 3")
			return "78"
		end
	end
end

function murder.pre_start()
	local players = {}
	
	for _, ply in pairs(player(0, "table")) do
		murder.int_fresh[ply] = false
		murder.int_murdered[ply] = false
		if (player(ply, "team") == 0) then parse("makect "..ply) end
	end
	
	for k, v in pairs(player(0, "table")) do if player(v, "team") ~= 0 then players[k] = v end end
	
	if (#players > 1) then
		local murderer = math.random(1, #players)
		murder.int_murderer = players[murderer]
		table.remove(players, murderer)
		
		for k, b in pairs(murder.int_bodies) do
			freeimage(b[1])
			table.remove(murder.int_bodies, k)
		end
		
		if (#players >= 1) then
			local gunner = math.random(1, #players)
			murder.int_gunner = players[gunner]
		end
		
		for _, ply in pairs(player(0, "table")) do
			murder.int_names[ply] = {murder.colors[math.random(1, #murder.colors)], murder.alphabet[math.random(1, #murder.alphabet)].." "..murder.alphabet[math.random(1, #murder.alphabet)]}
			hudtxt2(2, ply, string.char(169)..murder.int_names[ply][1]..murder.int_names[ply][2], 20, 400)
			murder.int_lootc[ply] = 0
			murder.int_fresh[ply] = false
		end
		parse("sv_sound murder/scream.wav")
	end
	
	murder.int_roundend = false
	murder.int_nokillsecs = 0
	
	msg(string.char(169).."255255255A new round has started")
end

function murder.start()
	if (#player(0, "table") == 1) then
		for _, ply in pairs(player(0, "table")) do hudtxt2(7, ply, string.char(169).."255255255Waiting for more players", 320, 100, 1) end
	else
		murder.int_blackout = image("gfx/sprites/block.bmp", 320, 240, 2)
		imagescale(murder.int_blackout, 20, 15)
		imagecolor(murder.int_blackout, 0, 0, 0)
		
		for _, ply in pairs(player(0, "table")) do
			for i = 3, 7 do
				hudtxt2(i, ply, "", 0, 0, 0)
			end
			if (player(ply, "team") ~= 0) then
				if (murder.int_murderer == ply) then
					hudtxt2(3, ply, string.char(169).."200030000You are the murderer", 320, 100, 1)
					hudtxt2(4, ply, string.char(169).."200030000Kill everyone", 320, 320, 1)
					hudtxt2(5, ply, string.char(169).."200030000Don't get caught", 320, 340, 1)
				elseif (murder.int_gunner == ply) then
					hudtxt2(3, ply, string.char(169).."000120255You are a bystander", 320, 100, 1)
					hudtxt2(4, ply, string.char(169).."120085245with a secret weapon", 320, 115, 1)
					hudtxt2(5, ply, string.char(169).."000120255There is a murderer on the loose", 320, 320, 1)
					hudtxt2(6, ply, string.char(169).."000120255Find and kill him", 320, 340, 1)
				else
					hudtxt2(3, ply, string.char(169).."000120255You are a bystander", 320, 100, 1)
					hudtxt2(4, ply, string.char(169).."000120255There is a murderer on the loose", 320, 320, 1)
					hudtxt2(5, ply, string.char(169).."000120255Don't get killed", 320, 340, 1)
				end
			end
		end
		
		freetimer("murder.begin")
		timer(10000, "murder.begin")
	end
end

function murder.always()
	reqcld(0, 2)
	local projlist = projectilelist(0,0)
	for _, p in pairs(projlist) do
		local ply = p.player
		if (murder.int_murderer == ply) then
			local tx, ty = math.floor(projectile(p.id, ply, "x")/32), math.floor(projectile(p.id, ply, "y")/32)
			for _, ply2 in pairs(player(0, "tableliving")) do
				if (ply2 ~= ply and tx == player(ply2, "tilex") and ty == player(ply2, "tiley")) then
					parse("freeprojectile "..p.id.." "..ply)
					murder.murder(ply2)
					parse("spawnitem 50 "..player(ply2, "tilex").." "..player(ply2, "tiley"))
				end
			end
		end
	end
end

function murder.clientdata(ply, m, a1, a2)
	for _, ply2 in pairs(player(0, "table")) do
		if (player(ply2, "team") ~= 0 and ply ~= ply2 and a1 >= player(ply2, "x") - 16 and a2 >= player(ply2, "y") - 16 and a1 <= player(ply2, "x") + 16 and a2 <= player(ply2, "y") + 16) then
			local name = #murder.int_names[ply2] > 2 and string.char(169)..murder.int_names[ply2][3]..murder.int_names[ply2][4] or string.char(169)..murder.int_names[ply2][1]..murder.int_names[ply2][2]
			hudtxt2(1, ply, name, 320 + player(ply2, "x") - player(ply, "x"), 240 + player(ply2, "y") - player(ply, "y") + 24, 1)
			return
		else
			hudtxt2(1, ply, "", 0, 0)
		end
	end
	
	for _, b in pairs(murder.int_bodies) do
		local ply2 = b[2]
		if (ply ~= b[2] and a1 >= b[3] - 16 and a2 >= b[4] - 16 and a1 <= b[3] + 16 and a2 <= b[4] + 16) then
			local name = string.char(169)..murder.int_names[ply2][1]..murder.int_names[ply2][2]
			hudtxt2(1, ply, name, 320 + b[3] - player(ply, "x"), 240 + b[4] - player(ply, "y") + 24, 1)
			break
		else
			hudtxt2(1, ply, "", 0, 0)
		end
	end
end

function murder.begin()
	if (#player(0, "table") > 1) then
		for _, ply in pairs(player(0, "table")) do
			for i = 3, 6 do
				hudtxt2(i, ply, "", 0, 0, 0)
			end
			if (murder.int_murderer ~= ply) then
				parse("strip "..ply.." 50")
			end
			parse("speedmod "..ply.." 0")
			freeimage(murder.int_blackout)
			murder.int_blackout = 0
		end
	end
end

function murder.deny()
	if (#player(0, "table") > 1) then
		return 1
	end
end

function murder.second()
	if (#player(0, "table") > 1) then
		if (murder.int_blackout == 0) then
			murder.int_nokillsecs = murder.int_nokillsecs + 1
			murder.int_lootcounter = murder.int_lootcounter + 1
			if (murder.int_nokillsecs >= 60) then
				if (murder.int_nokillsecs == 60) then
					msg2(murder.int_murderer, string.char(169).."200030000Your evil presence is showing...")
				end
				if (player(murder.int_murderer, "health") > 0) then
					parse('effect "smoke" '..player(murder.int_murderer, "x")..' '..player(murder.int_murderer, "y")..' 16 16')
				end
			end
			
			if (murder.int_lootcounter >= 15 and #murder.int_loot < 15) then
				local x, y = murder.int_randomtile()
				murder.int_loot[#murder.int_loot+1] = {image(murder.loot[math.random(1, #murder.loot)], x*32+16, y*32+16, 0), x, y}
				imagepos(murder.int_loot[#murder.int_loot][1], x*32+16, y*32+16, math.random(0, 359))
				murder.int_lootcounter = 0
			end
		end
		
		for _, ply in pairs(player(0, "table")) do
			if (murder.int_murderer ~= ply) then
				for _, id in pairs(playerweapons(ply)) do
					if (id == 50) then
						parse("equip "..ply.." 78")
						parse("setweapon "..ply.." 78")
						parse("strip "..ply.." 50")
					end
				end
			end
		end
	end
end

function murder.die(ply)
	if (#player(0, "table") > 1) then
		if (not murder.int_roundend) then
			parse("makespec "..ply)
			if (murder.int_murderer == ply) then
				table.remove(murder.int_names[ply], 4)
				table.remove(murder.int_names[ply], 3)
				hudtxt2(8, ply, "", 0, 0)
				msg(string.char(169).."000120255Bystanders win! "..string.char(169).."255255255The murderer was "..string.char(169)..murder.int_names[murder.int_murderer][1]..player(murder.int_murderer, "name")..", "..murder.int_names[murder.int_murderer][2])
				parse("restart 10")
				murder.endround()
				parse("sv_sound murder/bell.wav")
			elseif (#player(0, "tableliving") == 1 and murder.int_contains(player(0, "tableliving"), murder.int_murderer)) then
				msg(string.char(169).."200030000The murderer wins! "..string.char(169).."255255255He was "..string.char(169)..murder.int_names[murder.int_murderer][1]..player(murder.int_murderer, "name")..", "..murder.int_names[murder.int_murderer][2])
				parse("restart 10")
				murder.endround()
				parse("sv_sound murder/bell.wav")
			end
		end
	end
end

function murder.movetile(ply, x, y)
	if (#player(0, "table") > 1) then
		if (murder.int_murderer == ply and (murder.int_lootc[ply] and murder.int_lootc[ply] > 0 or false)) then
			for _, b in pairs(murder.int_bodies) do
				if (ply ~= b[2] and x == math.floor(b[3]/32) and y == math.floor(b[4]/32)) then
					hudtxt2(7, ply, string.char(169).."255255255[E] to disguise yourself as "..murder.int_names[b[2]][2].." for 1 loot", 320, 180, 1)
					return
				end
			end
		end
		hudtxt2(7, ply, "", 0, 0, 0)
	end
end

function murder.use(ply)
	if (#player(0, "table") > 1) then
		local x, y = player(ply, "tilex"), player(ply, "tiley")
		for lk, l in pairs(murder.int_loot) do
			if (l[2] == x and l[3] == y) then
				parse("sv_sound2 "..ply.." murder/chime.wav")
				freeimage(l[1])
				if not murder.int_lootc[ply] then murder.int_lootc[ply] = 0 end
				murder.int_lootc[ply] = murder.int_lootc[ply] + 1
				parse("setscore "..ply.." "..murder.int_lootc[ply])
				if (murder.int_lootc[ply] == 5 and murder.int_murderer ~= ply) then
					if (not murder.int_contains(playerweapons(ply), 3)) then
						parse("equip "..ply.." 3")
					end
					murder.int_shots[ply] = 5
					parse("setammo "..ply.." 3 1 "..murder.int_shots[ply])
				end
			end
		end
		
		if (murder.int_murderer == ply and (murder.int_lootc[ply] and murder.int_lootc[ply] > 0 or false)) then
			for _, b in pairs(murder.int_bodies) do
				if (ply ~= b[2] and x == math.floor(b[3]/32) and y == math.floor(b[4]/32)) then
					murder.int_names[ply][3] = murder.int_names[b[2]][1]
					murder.int_names[ply][4] = murder.int_names[b[2]][2]
					msg2(ply, string.char(169).."255255255You are now disguised as "..string.char(169)..murder.int_names[ply][3]..murder.int_names[ply][4])
					murder.int_lootc[ply] = murder.int_lootc[ply] - 1
					parse("setscore "..ply.." "..murder.int_lootc[ply])
					hudtxt2(8, ply, string.char(169).."255255255as "..string.char(169)..murder.int_names[ply][3]..murder.int_names[ply][4], 20, 415, 0)
				end
			end
		end
	end
end

function murder.endround()
	murder.int_roundend = true
end

function murder.hit(ply, src, wpn)
	if (#player(0, "table") > 1) then
		if (murder.int_blackout ~= 0) then
			return 1
		end
		
		if (wpn == 78) then
			return 1
		end
		
		if (wpn == 50) then
			murder.murder(ply)
			return 1
		end
		
		if (wpn == 3) then
			parse('customkill 0 "self-defence" '..ply)
			murder.int_bodies[#murder.int_bodies+1] = {image("gfx/murder/dead_body.png", player(ply, "x"), player(ply, "y"), 0), ply, player(ply, "x"), player(ply, "y")}
			imagepos(murder.int_bodies[#murder.int_bodies][1], player(ply, "x"), player(ply, "y"), math.random(0, 359))
			
			if (murder.int_murderer ~= ply) then
				local blind = image("gfx/sprites/block.bmp", 320, 240, 2, src)
				imagescale(blind, 20, 15)
				imagecolor(blind, 0, 0, 0)
				imagealpha(blind, 0)
				tween_alpha(blind, 1000, 1)
				timer(10000, "freeimage", blind)
				
				msg(string.char(169)..murder.int_names[src][1]..player(src, "name")..", "..murder.int_names[src][2].." "..string.char(169).."255255255killed an innocent bystander")
				murder.int_kinnoc[src] = true
				parse("strip "..src.." "..wpn)
				parse("spawnitem 3 "..player(src, "tilex").." "..player(src, "tiley"))
				timer(1000, "parse", "lua murder.int_kinnoc["..src.."]=nil")
			end
			
			return 1
		end
	end
end

function murder.team(ply)
	if (murder.int_fresh[ply] or murder.int_murdered[ply]) then
		return 1
	end
end

function murder.join(ply)
	murder.int_fresh[ply] = true
	
	local p = {}
	for _, id in pairs(player(0, "table")) do if player(id, "team") > 0 then p[#p+1] = id end end
	if (#p < 3) then
		freetimer("parse", "restart")
		freetimer("murder.endround")
		timer(5000, "parse", "restart")
		timer(5000, "murder.endround")
	end
end

function murder.attack2(ply)
	if (#player(0, "table") > 1) then
		if (murder.int_murderer == ply and player(ply, "weapontype") == 50) then
			parse("spawnprojectile "..ply.." 50 "..player(ply, "x").." "..player(ply, "y").." 128 "..player(ply, "rot"))
			parse("setweapon "..ply.." 78")
			parse("strip "..ply.." 50")
		end
	end
end

function murder.walkover(ply, _, item)
	if (#player(0, "table") > 1) then
		if (murder.int_murderer == ply) then
			if (item == 50) then
				return 0
			else
				return 1
			end
		else
			if (item == 3 and not murder.int_kinnoc[ply]) then
				return 0
			else
				return 1
			end
		end
	end
end

function murder.collect(ply, _, item, ain, a)
	if (#player(0, "table") > 1) then
		if (item == 3) then
			murder.int_shots[ply] = a
		end
	end
end

addhook("spawn", "murder.spawn")
addhook("reload", "murder.reload")
addhook("startround_prespawn", "murder.pre_start")
addhook("startround", "murder.start")
addhook("buy", "murder.deny")
addhook("drop", "murder.deny")
addhook("team", "murder.team")
addhook("always", "murder.always")
addhook("clientdata", "murder.clientdata")
addhook("hit", "murder.hit")
addhook("die", "murder.die")
addhook("endround", "murder.endround")
addhook("second", "murder.second")
addhook("movetile", "murder.movetile")
addhook("use", "murder.use")
addhook("attack2", "murder.attack2")
addhook("join", "murder.join")
addhook("walkover", "murder.walkover")
addhook("collect", "murder.collect")
murder.pre_start()
murder.start()